
#ifndef PLS_DATAFLOW_INTERNAL_NODE_H_
#define PLS_DATAFLOW_INTERNAL_NODE_H_

namespace pls {
namespace dataflow {
namespace internal {

class node {
  template<typename INS, typename OUTS>
  friend
  class graph;

  enum state { fresh, building, built, teardown };

 public:
  virtual int num_successors() const = 0;
  virtual node *successor_at(int pos) const = 0;

  virtual int instance_buffer_size() const = 0;
  virtual void init_instance_buffer(void *memory) const = 0;

  virtual bool is_fully_connected() const = 0;

  template<typename M, typename T>
  M *get_invocation(token<T> token) {
    return token.invocation().template get_instance_buffer<M>(memory_index_);
  }

  // TODO: Remove
  void set_memory_index(int i) { memory_index_ = i; }

 private:
  int memory_index_{0};
  node *direct_successor_;
  state state_{fresh};
};

}
}
}

#endif //PLS_DATAFLOW_INTERNAL_NODE_H_
